#
# backupftpovh.sh : V1.0
#
source /home/admin/config.sh
#
#mail a modifier pour etre averti des backups
EMAIL="xxxx@xxx.fr"
MAILSIOK="O"
#
JOUR=`date '+%w'`
MOIS=`date '+%m'`
JOURDUMOIS=`date '+%d'`
STARTTIME=`date +%s`
UNAME=`uname -n`
#
#pour traduire les codes d'erreur de ncftpput en texte
declare -a CDERR
CDERR[1]="Could not connect to remote host."
CDERR[2]="Could not connect to remote host - t
imed out."
CDERR[3]="Transfer failed."
CDERR[4]="Transfer failed - timed out."
CDERR[5]="Directory change failed."
CDERR[6]="Directory change failed - timed out.
"
CDERR[7]="Malformed URL."
CDERR[8]="Usage error."
CDERR[9]="Error in login configuration file."
CDERR[10]="Library initialization failed."
CDERR[11]="Session initialization failed."
CDERR[142]="Delai depassé pour la connexion."
#
# CONF
#
# test si 1er du mois
if [ "$JOURDUMOIS" == "01" ]; then
	
	#
	REPS="/etc/mysql /usr/local/apache/conf /usr/local/lib/php5 /etc/bind"
	tar cfz /home/backup/conf/m-$MOIS-conf.tar.gz $REPS
	# transfert FTP de toutes les bases sur le distant
	ncftpput -m -u $USER -p $PASS $SERVER /conf /home/backup/conf/*.gz
	RESULT=$?
	if [ "$RESULT" != "0" ]; then
		DATE=`date +%H:%M:%S`
		echo -e "[$0] -->ERREUR: ${CDERR[$RESULT]} à $DATE Backup NON effectué." | mail -s "$UNAME : ERREUR BACKUPFTP : transfert conf de mysql" $EMAIL
		exit $RESULT
	fi
fi
#
# WEB
#
rm -f /home/backup/web/*
#
# on boucle sur tous les dossiers de /home
ls /home | while read nom
do
dir="/home/$nom"
if [ -d $dir ] && [ $nom != "admin" ] && [ $nom != "backup" ] && [ $nom != "log" ] && [ $nom != "tmp" ] && [ $nom != "ovh" ] && [ $nom != "ovhm" ]  && [ $nom != "ftp" ] && [ $nom != "mysql" ] && [ $nom != "lost+found" ] && [ $nom != "vpopmail" ]
then
# creation archive locale
tar cfz /home/backup/web/j-$JOUR-$nom.tar.gz $dir
fi
done
#
# transfert FTP de toutes les archives sur le distant
ncftpput -m -u $USER -p $PASS $SERVER /web /home/backup/web/*.gz
RESULT=$?
if [ "$RESULT" != "0" ]; then
  DATE=`date +%H:%M:%S`
  echo -e "[$0] -->ERREUR: ${CDERR[$RESULT]} à $DATE Backup NON effectué." | mail -s "$UNAME : ERREUR BACKUPFTP : transfert ftp de web" $EMAIL
  exit $RESULT
fi  
#
#
# MYSQL
#
rm -f /home/backup/mysql/*
#
# Emplacemment des different prog utilisé, laissez tel quel si vous n'avez rien bidouillé (sinon updatedb & locate)
MYSQL="$(which mysql)"
MYSQLDUMP="$(which mysqldump)"
CHOWN="$(which chown)"
CHMOD="$(which chmod)"
GZIP="$(which gzip)"

# Emplacemment du dossier de backup local
DEST=""

#Repertoire ou on met le .sql
DEST_mysql="/home/backup/mysql"
# Databases a ne pas sauvegarder séparer par des espaces
IGGY=""

# On initialise les variables
FILE=""
DBS=""

#on crée le repertoire
[ ! -d $DEST_mysql ] && mkdir -p $DEST_mysql || :

# On liste les bases de donnees
DBS="$($MYSQL -u $Mysql_User -h $Mysql_host -p$Mysql_Paswd -Bse 'show databases')"

for db in $DBS
do
    skipdb=-1
    if [ "$IGGY" != "" ];
	then
	for i in $IGGY
		do
		[ "$db" == "$i" ] && skipdb=1 || :
		done
    fi

    if [ "$skipdb" == "-1" ] ; then
	 FILE="$DEST_mysql/j-$JOUR-$db.sql.gz"
	 # test si 1er du mois
	 if [ "$JOURDUMOIS" == "01" ]; then
	 FILE="$DEST_mysql/m-$MOIS-$db.sql.gz"
	 fi
	 # On boucle, et on dump toutes les bases et on les compresse
	 $MYSQLDUMP -u $Mysql_User -h $Mysql_host -p$Mysql_Paswd $db | $GZIP -9 > $FILE
    fi
done
# transfert FTP de toutes les bases sur le distant
ncftpput -m -u $USER -p $PASS $SERVER /mysql /home/backup/mysql/*.gz
RESULT=$?
if [ "$RESULT" != "0" ]; then
  DATE=`date +%H:%M:%S`
  echo -e "[$0] -->ERREUR: ${CDERR[$RESULT]} à $DATE Backup NON effectué." | mail -s "$UNAME : ERREUR BACKUPFTP : transfert ftp de mysql" $EMAIL
  exit $RESULT
fi	
#
#
# Compte rendu de fin
#
TOTALTIME=$(((`date +%s`-$STARTTIME)/60))
DATE=`date +%H:%M:%S`
if [ "$MAILSIOK" = "O" ]; then
   echo -e "[$0] -->Backup effectué à $DATE Status: OK\nDurée du backup: $TOTALTIME minutes\n" | mail -s "$UNAME : BACKUPFTP OK -- $TOTALTIME minutes" $EMAIL
fi
			 
